#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;

//#include "imagefilter.h"

namespace FilterTemplate {

	public ref class SettingsForm : public System::Windows::Forms::Form
	{

	public:
		filtersettings* FilterSetting;
		bool FilterCancelled, MouseButtonDown;

		Bitmap^ PreviewBitmap;
		Rectangle SourceRect, DestinationRect;
		int SWidth, SHeight, LastX, LastY;

		System::Drawing::Imaging::PixelFormat pFormat;


	public:
		SettingsForm(filtersettings* fs)
		{
			InitializeComponent();

			FilterSetting = fs;

			SWidth = fs->width;
			SHeight = fs->height;

			FilterCancelled = true;

			if (fs->channelcountin == 1)
			{
				PreviewBitmap = gcnew Bitmap(Preview->ClientSize.Width, Preview->ClientSize.Height, pFormat = PixelFormat::Format8bppIndexed);
				ColorPalette^ cPal = PreviewBitmap->Palette;
				for (int i = 0; i < 256; i++) cPal->Entries[i] = Color::FromArgb(i, i, i);
				PreviewBitmap->Palette = cPal;
			}
			else
			{
				PreviewBitmap = gcnew Bitmap(Preview->ClientSize.Width, Preview->ClientSize.Height, pFormat = PixelFormat::Format24bppRgb);
			} 

			DestinationRect.X = (SWidth < Preview->ClientSize.Width) ? ((Preview->ClientSize.Width - SWidth) / 2) : 0;
			DestinationRect.Y = (SHeight < Preview->ClientSize.Height) ? ((Preview->ClientSize.Height - SHeight) / 2) : 0;
			DestinationRect.Width = (DestinationRect.X) ? SWidth : Preview->ClientSize.Width;
			DestinationRect.Height = (DestinationRect.Y) ? SHeight : Preview->ClientSize.Height; 

			SourceRect.X = 0;
			SourceRect.Y = 0;
			SourceRect.Width = DestinationRect.Width;   // SHOULD BE EQUAL !!!
			SourceRect.Height = DestinationRect.Height; // SHOULD BE EQUAL !!!

			RadiusScrollBar->Minimum = 1;
			RadiusScrollBar->Maximum = 10;
			RadiusScrollBar->Value   = FilterSetting->windowsize;
			RadiusScrollBar_Scroll(nullptr, nullptr);

			MouseButtonDown = false;
		}

	protected:

		~SettingsForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Label^  RadiusLabel;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Button^  ButtonApply;
	private: System::Windows::Forms::Button^  ButtonCancel;
	private: System::Windows::Forms::HScrollBar^  RadiusScrollBar;
	private: System::Windows::Forms::PictureBox^  Preview;
	private: System::ComponentModel::IContainer^  components;

		void InitializeComponent(void)
		{
			this->Preview = (gcnew System::Windows::Forms::PictureBox());
			this->RadiusLabel = (gcnew System::Windows::Forms::Label());
			this->ButtonApply = (gcnew System::Windows::Forms::Button());
			this->ButtonCancel = (gcnew System::Windows::Forms::Button());
			this->RadiusScrollBar = (gcnew System::Windows::Forms::HScrollBar());
			this->label1 = (gcnew System::Windows::Forms::Label());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Preview))->BeginInit();
			this->SuspendLayout();
			// 
			// Preview
			// 
			this->Preview->BorderStyle = System::Windows::Forms::BorderStyle::Fixed3D;
			this->Preview->Cursor = System::Windows::Forms::Cursors::NoMove2D;
			this->Preview->Location = System::Drawing::Point(12, 12);
			this->Preview->Name = L"Preview";
			this->Preview->Size = System::Drawing::Size(154, 154);
			this->Preview->TabIndex = 0;
			this->Preview->TabStop = false;
			this->Preview->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &SettingsForm::Preview_MouseDown);
			this->Preview->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &SettingsForm::Preview_MouseMove);
			this->Preview->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &SettingsForm::Preview_OnPaint);
			this->Preview->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &SettingsForm::Preview_MouseUp);
			// 
			// RadiusLabel
			// 
			this->RadiusLabel->Location = System::Drawing::Point(181, 53);
			this->RadiusLabel->Name = L"RadiusLabel";
			this->RadiusLabel->Size = System::Drawing::Size(242, 23);
			this->RadiusLabel->TabIndex = 1;
			this->RadiusLabel->Text = L"Radius: 1";
			this->RadiusLabel->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// ButtonApply
			// 
			this->ButtonApply->Location = System::Drawing::Point(183, 143);
			this->ButtonApply->Name = L"ButtonApply";
			this->ButtonApply->Size = System::Drawing::Size(75, 23);
			this->ButtonApply->TabIndex = 2;
			this->ButtonApply->Text = L"Apply";
			this->ButtonApply->UseVisualStyleBackColor = true;
			this->ButtonApply->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonApply_Click);
			// 
			// ButtonCancel
			// 
			this->ButtonCancel->Location = System::Drawing::Point(264, 143);
			this->ButtonCancel->Name = L"ButtonCancel";
			this->ButtonCancel->Size = System::Drawing::Size(75, 23);
			this->ButtonCancel->TabIndex = 3;
			this->ButtonCancel->Text = L"Cancel";
			this->ButtonCancel->UseVisualStyleBackColor = true;
			this->ButtonCancel->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonCancel_Click);
			// 
			// RadiusScrollBar
			// 
			this->RadiusScrollBar->Cursor = System::Windows::Forms::Cursors::Default;
			this->RadiusScrollBar->LargeChange = 1;
			this->RadiusScrollBar->Location = System::Drawing::Point(184, 89);
			this->RadiusScrollBar->Maximum = 10;
			this->RadiusScrollBar->Name = L"RadiusScrollBar";
			this->RadiusScrollBar->Size = System::Drawing::Size(242, 21);
			this->RadiusScrollBar->TabIndex = 4;
			this->RadiusScrollBar->Value = 1;
			this->RadiusScrollBar->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::RadiusScrollBar_Scroll);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(181, 12);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(98, 13);
			this->label1->TabIndex = 5;
			this->label1->Text = L"Mean filter settings:";
			// 
			// SettingsForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::Silver;
			this->ClientSize = System::Drawing::Size(490, 178);
			this->Controls->Add(this->RadiusScrollBar);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->ButtonCancel);
			this->Controls->Add(this->ButtonApply);
			this->Controls->Add(this->RadiusLabel);
			this->Controls->Add(this->Preview);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"SettingsForm";
			this->ShowIcon = false;
			this->ShowInTaskbar = false;
			this->Text = L"Mean Filter";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Preview))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}

	public:
		void RefreshPreview(bool applyfilter)
		{
			BitmapData^ bd = PreviewBitmap->LockBits( Rectangle(0, 0, PreviewBitmap->Width, PreviewBitmap->Height), ImageLockMode::ReadWrite, pFormat);

			FilterSetting->strideout = bd->Stride;
			FilterSetting->dataout = (Byte*)(void*)bd->Scan0;

			if (applyfilter)
				FilterSpace::ImageFilter::FilterCore(FilterSetting, SourceRect.X, SourceRect.Y, SourceRect.Width, SourceRect.Height);
			else
				FilterSpace::ImageFilter::ClipImage( FilterSetting, SourceRect.X, SourceRect.Y, SourceRect.Width, SourceRect.Height);

			PreviewBitmap->UnlockBits(bd);
			this->Refresh();
		}

	private: 
		System::Void ButtonApply_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			FilterCancelled = false;
			this->Close();
		}

		System::Void ButtonCancel_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			this->Close();
		}

		System::Void Preview_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		{
			if (e->Button == System::Windows::Forms::MouseButtons::Left) 
			{
				MouseButtonDown = true;
				LastX = e->X;
				LastY = e->Y;
				RefreshPreview(false);
			}
		}

		System::Void Preview_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		{
			if (!MouseButtonDown) return;
			if (!DestinationRect.X)
			{
				SourceRect.X -= e->X - LastX;
				if (SourceRect.X < 0) SourceRect.X = 0;
				if (SourceRect.X >= SWidth - DestinationRect.Width) SourceRect.X = SWidth - DestinationRect.Width - 1;
			}
			if (!DestinationRect.Y)
			{
				SourceRect.Y -= e->Y - LastY;
				if (SourceRect.Y < 0) SourceRect.Y = 0;
				if (SourceRect.Y >= SHeight - DestinationRect.Height) SourceRect.Y = SHeight - DestinationRect.Height - 1;
			}
			RefreshPreview(false);
			LastX = e->X;
			LastY = e->Y;
		}

		System::Void Preview_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		{
			if (e->Button == System::Windows::Forms::MouseButtons::Left) MouseButtonDown = false;
			if (!MouseButtonDown) RefreshPreview(true);
		}

		System::Void Preview_OnPaint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) 
		{
			Graphics^ g = e->Graphics;
			Rectangle r = Rectangle(0, 0, DestinationRect.Width, DestinationRect.Height);
			g->DrawImage(PreviewBitmap, DestinationRect, r, GraphicsUnit::Pixel);
		}

		System::Void RadiusScrollBar_Scroll(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e) 
		{
			FilterSetting->windowsize = RadiusScrollBar->Value;
			RadiusLabel->Text = "Radius: " + RadiusScrollBar->Value.ToString();
			RefreshPreview(true);
		}
};
}
